<?php

namespace MiHoBasePlugin;

use Shopware\Bundle\AttributeBundle\Service\CrudService;
use Shopware\Components\Plugin;
use Shopware\Components\Plugin\Context\InstallContext;
use Shopware\Components\Plugin\Context\UninstallContext;
//use Shopware\Components\License;

class MiHoBasePlugin extends Plugin {


	/**
	 * @param InstallContext $installContext
	 */
	public function install( InstallContext $installContext ) {
		parent::install( $installContext );
		$this->createFirstAttribute();
	}


	/**
	 * @param UninstallContext $uninstallContext
	 */
	public function uninstall( UninstallContext $uninstallContext ) {
		parent::install( $uninstallContext );
		$this->deleteAttribute();
	}

	/**
	 * @inheritdoc
	 */
	public static function getSubscribedEvents() {
		return [
		];
	}

	/**
	 * @throws \Exception
	 */
	private function createFirstAttribute() {

		/** @var CrudService $crud */
		$crud = $this->container->get( 'shopware_attribute.crud_service' );

		$crud->update( 's_user_attributes', 'pet_name', 'string', [
			'label'            => 'Customers pet name',
			'custom'           => false,
			'displayInBackend' => true
		] );

		$metaDataCache = Shopware()->Models()->getConfiguration()->getMetadataCacheImpl();
		$metaDataCache->deleteAll();
		Shopware()->Models()->generateAttributeModels( [ 's_user_attributes' ] );

	}


	/**
	 * @throws \Exception
	 */
	private function deleteAttribute() {

		/** @var CrudService $crud */
		$crud = $this->container->get( 'shopware_attribute.crud_service' );
		$crud->delete( 's_user_attributes', 'pet_name' );

	}



}
