<?php

namespace MiHoBasePlugin\Subscriber;

use Enlight\Event\SubscriberInterface;
use Enlight_Template_Manager;


class TemplateRegistration implements SubscriberInterface {
	/**
	 * @var Enlight_Template_Manager
	 */
	private $templateManager;

	/**
	 * @var string
	 */
	private $pluginBaseDirectory;

	/**
	 * @param Enlight_Template_Manager
	 * @param $pluginDirectory
	 */
	public function __construct( Enlight_Template_Manager $templateManager, $pluginDirectory ) {
		$this->pluginDirectory = $pluginDirectory;
		$this->templateManager = $templateManager;
	}


	/**
	 * get events for subscriber
	 *
	 * @return array
	 */
	public static function getSubscribedEvents() {
		return [
			'Enlight_Controller_Action_PostDispatchSecure_Frontend_Register' => 'onPostDispatchSecureFrontendRegister'
		];
	}

	/**
	 * Post dispatch event for registration process
	 *
	 * @param \Enlight_Event_EventArgs $arguments
	 */
	public function onPostDispatchSecureFrontendRegister( \Enlight_Event_EventArgs $arguments ) {
		$this->templateManager->addTemplateDir( $this->pluginDirectory . '/Resources/views' );
	}

}